﻿using System.Collections.Generic;

namespace Ocelot.Configuration
{
    public class AuthenticationOptions
    {
        public AuthenticationOptions(string provider, List<string> allowedScopes, IAuthenticationConfig config)
        {
            Provider = provider;
            AllowedScopes = allowedScopes;
            Config = config;
        }

        public string Provider { get; private set; }
        
        public List<string> AllowedScopes { get; private set; }

        public IAuthenticationConfig Config { get; }
    }


    public interface IAuthenticationConfig
    {
    }

    public class IdentityServerConfig : IAuthenticationConfig
    {
        public IdentityServerConfig(string providerRootUrl, string apiName, bool requireHttps, string apiSecret)
        {
            ProviderRootUrl = providerRootUrl;
            ApiName = apiName;
            RequireHttps = requireHttps;
            ApiSecret = apiSecret;
        }

        public string ProviderRootUrl { get; private set; }
        public string ApiName { get; private set; }
        public string ApiSecret { get; private set; }
        public bool RequireHttps { get; private set; }
    }
}
